// Install puppeteer
const puppeteer = require('puppeteer');

// Install NodeMailer
const nodemailer = require('nodemailer');

// Read JSON file
const fs = require('fs');
const data = fs.readFileSync('config.json');

//Initialize lastDomains
const lastDomain = JSON.parse(data).lastDomain;

console.log(lastDomain)
//Initialize domains array
let domains = [];

//Initialize is completed
let isCompleted = false;

function delay(time) {
    return new Promise(function (resolve) {
        setTimeout(resolve, time)
    });
}


//Start puppeteer on a headless browser and navigate to the page
(async () => {
        console.log("Initializing browser...");
        const browser = await puppeteer.launch();
        const page = await browser.newPage();
        await page.setViewport({
            width: 1920,
            height: 1080,
        });

        await page.goto('https://www.expireddomains.net/login/');
        let acceptBeforeUnload = dialog => dialog.type() === "beforeunload" && dialog.accept();
        page.on("dialog", acceptBeforeUnload);
        // puppeteer wait for 2 seconds
        await delay(2000);
        console.log("Connexion en cours...")
        // Wait for input username to be visible
        let login = await page.waitForSelector('input#inputLogin');
        // Wait for input password to be visible
        let password = await page.waitForSelector('input#inputPassword');
        // Type username
        await login.type('elladaniii');
        // Type password
        await password.type('4NAAzw6KjC');
        //Delay 2 seconds
        await delay(2000);
        // Wait for the button to be visible
        const button = await page.waitForSelector('.col-sm-12 button');
        // Click on the login button
        await button.click();
        //Delay 2 seconds
        await delay(2000);
        console.log("Connexion réussie !");
        // Go to the French expired domains page
        await page.goto('https://member.expireddomains.net/domains/expiredfr/');
        // Loop through the elements in page
        while (!isCompleted) {
            //Wait for 2 seconds
            await delay(2000);
            const elements = await page.$$('a.namelinks');
            console.log(elements.length);
            for (let i = 0; i < elements.length; i++) {
                // Get the text of the element
                const text = await page.evaluate(el => el.textContent, elements[i]);
                if(text.includes(lastDomain)){
                    isCompleted = true;
                    break;
                }
                domains.push(text);
            }
            //Wait for 2 seconds
            await delay(2000);
            // Click on the next button
            const nextButton = await page.waitForSelector('div:nth-of-type(3) a.next');
            await nextButton.click();
        }
        // Write the first domains in the config file
        if(domains.length === 0) {
            await browser.close();
            return;
        }
        fs.writeFileSync('config.json', JSON.stringify({lastDomain: domains[0]}));
        // Send an email with the domains
        let transporter = nodemailer.createTransport({
            host: "node113-eu.n0c.com",
            port: 587,
            secure: false, // true for 465, false for other ports
            auth: {
                user: 'domains-hunter@tenesiz.fr',
                pass: 'A15fe18z4aDEa98'
            }
        }
        );
        let mailOptions = {
            from: 'domains-hunter@tenesiz.fr',
            to: 'eric@exterlead.fr',
            subject: 'Expired Domains - ' + new Date().toLocaleDateString() +' - ' + new Date().toLocaleTimeString(),
            text: 'Domaines du ' + new Date().toLocaleDateString() +' - ' + new Date().toLocaleTimeString(),
            attachments: [
                {
                    filename: 'domains.txt',
                    content: domains.join('\n')
                }
            ]
        };
        transporter.sendMail(mailOptions, function (error, info) {
            if (error) {
                console.log(error);
            } else {
                console.log('Email sent: ' + info.response);
            }
        }
        );

        console.log(domains);
        console.log("Done");
        await browser.close();
    }
)();